#!/usr/bin/sh

# RPM install model
# failover_command='...failover.sh %H %R %h %M'

NEW_MASTER_DBNODE=$1 # %H
PGDATA=$2 # %R
LOGFILE="a.txt"

date > $LOGFILE
echo "%H NEW MASTER DBNODE: $1" >> $LOGFILE
echo "%R NEW MASTER PGDATA: $2" >> $LOGFILE
echo "%h DISCONNECT DBNODE: $3" >> $LOGFILE
echo "%M OLD MASTER DBNODE: $4" >> $LOGFILE

PGUSER=postgres
DBNAME=postgres
PGCONF_FILE=$PGDATA/postgresql.conf
EMPTY_STR="''"
DBNODE0="192.168.56.246"
DBNODE1="192.168.56.243"

## check dbnode type, primary or standby
DB_ROLE=`psql $DBNAME -h $NEW_MASTER_DBNODE -c "SELECT pg_is_in_recovery()" -U postgres | grep f | wc -l`
# primary dbnode = 1
# standby dbnode = 0

# if NEW MASTER DBNODE is primary dbnode, 
# stop sync replication mode.
echo "STANDBY DBNODE is down." >> $LOGFILE
echo "stop sync replication mode." >> $LOGFILE
if [ $DB_ROLE = 1 ]; then
    echo '
        psql -U '$PGUSER' -c "ALTER SYSTEM SET synchronous_standby_names TO '${EMPTY_STR}' " '$DBNAME'
        pg_ctl reload -D '$PGDATA'
    ' > script_p1.sh
    /usr/bin/ssh -i /var/lib/pgsql/.ssh/id_dsa $NEW_MASTER_DBNODE < script_p1.sh
    exit 0;
fi

# if NEW MASTER DBNODE is standby dbnode, 
# stop sync replication mode and promote standby dbnode.
echo "MASTER DBNODE is down." >> $LOGFILE
echo "stop sync replication mode and promote STANDBY DBNODE." >> $LOGFILE
echo '
        psql -U '$PGUSER' -c "ALTER SYSTEM SET synchronous_standby_names TO '${EMPTY_STR}' " '$DBNAME'
        pg_ctl reload -D '$PGDATA'
        pg_ctl promote -D '$PGDATA'
' > script_p2.sh
/usr/bin/ssh -i /var/lib/pgsql/.ssh/id_dsa $NEW_MASTER_DBNODE < script_p2.sh

